=== debian/changelog ===
openscad (2019.05-3ubuntu5) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 08:54:58 +0100

openscad (2019.05-3ubuntu4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:22:19 +0100

openscad (2019.05-3ubuntu3) focal; urgency=medium

  * No-change rebuild against libboost-regex1.67.0-icu65

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Feb 2020 18:55:44 +0000

openscad (2019.05-3ubuntu2) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 21:14:16 +0000

openscad (2019.05-3ubuntu1) focal; urgency=medium

  * Merge from debian unstable. Remaining changes:
    - debian/rules: build with --no-parallel to workaround builders
      failing the build due to lack on memory on some architectures

 -- Rik Mills <rikmills@kde.org>  Thu, 09 Jan 2020 19:51:46 +0000

openscad (2019.05-3) unstable; urgency=medium

  * Mark python3 build-dep as :any to fix FTCBFS (from Helmut Grohne)
    (Closes: #941100).
  * Transition to CGAL5 (patches from Joachim Reichel).
  
 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Wed, 04 Dec 2019 19:47:49 +0100

openscad (2019.05-2ubuntu3) focal; urgency=medium

  * No-change rebuild against libcgal-qt5-14

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 17 Dec 2019 16:12:17 +0000

openscad (2019.05-2ubuntu2) focal; urgency=medium

  * No-change rebuild against libqscintilla2-qt5-15.

 -- Rik Mills <rikmills@kde.org>  Thu, 21 Nov 2019 09:55:21 +0000

openscad (2019.05-2ubuntu1) focal; urgency=medium

  * debian/rules:
    - build with --no-parallel to workaround builders failing the build
      due to lack on memory on some architectures

 -- Sebastien Bacher <seb128@ubuntu.com>  Wed, 20 Nov 2019 16:01:50 +0100

openscad (2019.05-2) unstable; urgency=medium

  * Fix some testsuite failures (Closes: #795300).
  * Standards-version updated to 4.4.0.
  * debhelper-compat version bumped to 12.
  * Mark package openscad-testing-data as Multi-Arch: foreign
  * Clean up some lintian warnings.

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Tue, 06 Aug 2019 23:19:39 +0200

openscad (2019.05-1) unstable; urgency=medium

  * New upstream version
  * Remove two patches that have been accepted upstream
  * New build dependency libdouble-conversion-dev
  * Enable SVG and customizer tests as those are now non-experimental
    features enabled in the debian build.
  * Try to fix not reproducible build of openscad-testing-data
  * Update Standards-Version to latest 4.3.0

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Tue, 23 Jul 2019 10:08:45 +0200
