=== debian/tests/control ===
Test-Command: openscad-testrun --virtual --directory $AUTOPKGTEST_TMP/testrun
Depends: openscad-testing, xvfb
Restrictions: allow-stderr
